diff --git a/package.xml b/package.xml
index fde1f535..bcd797b7 100644
--- a/package.xml
+++ b/package.xml
@@ -10,11 +10,11 @@
   <email>pthreads@pthreads.org</email>
   <active>yes</active>
  </lead>
- <date>2014-03-17</date>
- <time>17:00:00</time>
+ <date>2014-03-27</date>
+ <time>08:00:00</time>
  <version>
-  <release>2.0.2</release>
-  <api>2.0.2</api>
+  <release>2.0.4</release>
+  <api>2.0.4</api>
  </version>
  <stability>
   <release>stable</release>
@@ -22,7 +22,9 @@
  </stability>
  <license uri="http://www.php.net/license">PHP License</license>
  <notes>
-  Fix build in BSD and other *nix where PTHREAD_MUTEX_RECURSIVE_NP is enum
+  fix memory errors introduced in 2.0.0
+  fix 5.3 build
+  synchronize versions
  </notes>
  <contents>
   <dir name="/">
diff --git a/php_pthreads.h b/php_pthreads.h
index eb498db7..acf5f7bf 100644
--- a/php_pthreads.h
+++ b/php_pthreads.h
@@ -18,7 +18,7 @@
 #ifndef HAVE_PHP_PTHREADS_H
 #define HAVE_PHP_PTHREADS_H
 #define PHP_PTHREADS_EXTNAME "pthreads"
-#define PHP_PTHREADS_VERSION "2.0.1"
+#define PHP_PTHREADS_VERSION "2.0.4"
 
 PHP_MINIT_FUNCTION(pthreads);
 PHP_MSHUTDOWN_FUNCTION(pthreads);
diff --git a/src/object.c b/src/object.c
index 13121ca0..90d3dbf0 100644
--- a/src/object.c
+++ b/src/object.c
@@ -451,17 +451,40 @@ static int pthreads_connect(PTHREAD source, PTHREAD destination TSRMLS_DC) {
 } /* }}} */
 
 /* {{{ pthreads_base_init */
-static inline void pthreads_base_init(PTHREAD base TSRMLS_DC) {
-	HashPosition position;
+static inline void pthreads_base_init(PTHREAD base TSRMLS_DC) {	
 	zend_class_entry *entry = base->std.ce;
-	HashTable *table = &entry->properties_info;
-	zend_property_info *info = NULL;
+	const char *property_name = NULL;
+	int property_name_len = 0;
 	const char *class_name = estrndup(
 		entry->name, entry->name_length);
 	char *class_free = (char*) class_name;
-	const char *property_name = NULL;
-	int property_name_len = 0;
+	HashPosition position;
+	
+#if PHP_VERSION_ID < 50400
+	zval **property;
 	
+	for (zend_hash_internal_pointer_reset_ex(&entry->default_properties, &position);
+		zend_hash_get_current_data_ex(&entry->default_properties, (void**) &property, &position)==SUCCESS;
+		zend_hash_move_forward_ex(&entry->default_properties, &position)) {
+
+		char *n;
+		ulong i;
+		uint l;
+
+		if (zend_hash_get_current_key_ex(&entry->default_properties, &n, &l, &i, 0, &position)) {
+			zend_unmangle_property_name(
+				n, l,
+				(char**)&class_name,
+				(char**)&property_name);
+			property_name_len = strlen(property_name);
+			pthreads_store_write(base->store, property_name, property_name_len, property TSRMLS_CC);
+			
+		}
+	}
+#else
+	HashTable *table = &entry->properties_info;
+	zend_property_info *info = NULL;
+
 	for (zend_hash_internal_pointer_reset_ex(table, &position);
 		 zend_hash_get_current_data_ex(table, (void**) &info, &position) == SUCCESS;
 		 zend_hash_move_forward_ex(table, &position)) {
@@ -480,10 +503,9 @@ static inline void pthreads_base_init(PTHREAD base TSRMLS_DC) {
 			info->name, info->name_length,
 			&class_name,
 			&property_name);
-			
+
 		property_name_len = strlen(property_name);
 #endif
-
 		if (entry->default_properties_table &&
 			entry->default_properties_table[info->offset]) {
 			pthreads_store_write(
@@ -495,8 +517,9 @@ static inline void pthreads_base_init(PTHREAD base TSRMLS_DC) {
 				(char*) property_name, property_name_len,
 				&EG(uninitialized_zval_ptr) TSRMLS_CC);
 	}
-	
-	efree((char*)class_free);
+#endif
+
+	efree((char*)class_free);	
 } /* }}} */
 
 /* {{{ pthreads base constructor */
diff --git a/tests/global-voodoo.phpt b/tests/global-voodoo.phpt
index 80f21e2d..846f7c10 100644
--- a/tests/global-voodoo.phpt
+++ b/tests/global-voodoo.phpt
@@ -1,5 +1,7 @@
 --TEST--
 Test Thread::globally
+--SKIPIF--
+<?php if(PHP_VERSION_ID < 50400) die("skip do not run for <5.4"); ?>
 --DESCRIPTION--
 Test globally voodoo
 --FILE--
diff --git a/tests/globals.phpt b/tests/globals.phpt
index d04f4229..f97c760b 100644
--- a/tests/globals.phpt
+++ b/tests/globals.phpt
@@ -23,8 +23,8 @@ $test = new Test();
 $test->start(PTHREADS_INHERIT_ALL | PTHREADS_ALLOW_GLOBALS);
 $test->join();
 ?>
---EXPECT--
-object(stdClass)#1 (3) {
+--EXPECTF--
+object(stdClass)#%d (%d) {
   ["one"]=>
   string(3) "one"
   ["two"]=>
diff --git a/tests/trait-aliases.phpt b/tests/trait-aliases.phpt
index 43832c33..b1db8579 100644
--- a/tests/trait-aliases.phpt
+++ b/tests/trait-aliases.phpt
@@ -1,5 +1,7 @@
 --TEST--
 Test trait aliases
+--SKIPIF--
+<?php if(PHP_VERSION_ID < 50400) die("skip do not run for <5.4"); ?>
 --DESCRIPTION--
 Fix bug #274, trait aliases causing memory errors
 --FILE--
